/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 22.09.2008
Author  : 
Company : 
Comments: 


Chip type           : ATmega32
Program type        : Application
Fuses Settings      : CKSEL = 1110, SUT = 01, CKOPT = 0
Clock frequency     : 16,000000 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 512
*****************************************************/

#include <mega32.h>
#include <delay.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <spi.h>
#include <sleep.h>
#include "main.h"
#include "mmcCommand.h"
#include "mmc.h"
#include "types.h"

//  
DWORD F_StartCluster, //    (  .. )
	F_ClusterBuf, //    ,       ( 0    )
	F_ClusterNum, //         
	F_Size, //   
	CelBlock, //    ( ) 
	DrobBlock;  //     

//DWORD cluster_tmp;
BYTE data;


typedef struct {
	BYTE id_riff[4];        // 4 byte
	DWORD len_riff;         // 4 byte

	BYTE id_chuck[4];       // 4 byte
	BYTE fmt[4];            // 4 byte
	DWORD len_chuck;        // 4 byte

	WORD  type;             // 2 byte
	WORD  channels;         // 2 byte
	DWORD freq;             // 4 byte
	DWORD bytes;            // 4 byte
	WORD  align;            // 2 byte
	WORD  bits;             // 2 byte

	BYTE id_data[4];        // 4 byte
	DWORD len_data;         // 4 byte
} TW; // 44 byte

// ========================
//void PrintFile (DWORD); 

//=============================================================================
BYTE MMC_Command(char cmd, DWORD arg) {
        char r1,retry;
        retry=0;

        // 
        spi(cmd|0x40);//
        spi(arg>>24);//
        spi(arg>>16);
        spi(arg>>8);
        spi(arg); 
        spi(0x95);//      

        // ,     64 a,      0FF
        while((r1=spi(0xff))==0xFF)if(retry++>252)break;

        // 
        return r1;
}

//=============================================================================
BYTE MMC_SendCommand(char cmd, DWORD arg) {
        char r1;

        SD_CS_ON();
        r1=MMC_Command(cmd,arg);
        SD_CS_OFF();
        spi(0xFF);

        return r1; 
}

//=============================================================================
char MMC_Init(void) {
        BYTE retry,r1;
        r1=retry=0;

        //    SPI
        do {
                spi(0xFF); 
                spi(0xFF); 
                spi(0xFF); 
                spi(0xFF); 
                spi(0xFF); 
                spi(0xFF); 
                spi(0xFF); 
                spi(0xFF); 
                spi(0xFF); 
                spi(0xFF); 
                r1=MMC_SendCommand(MMC_GO_IDLE_STATE, 0);

                delay_ms(1);
                // printf ("%c -1- ",r1);
                
                retry++;
                if(retry>10)return 10;
        } while(r1!=0x01);  


        // 
        retry=0;
        do { 
                r1=MMC_SendCommand(MMC_SEND_OP_COND,0);
                delay_ms(1);
                //printf ("%c -2- ",r1);
                retry++;
                if(retry>250)return r1;
        } while(r1);

        // CRC 
        r1=MMC_SendCommand(MMC_CRC_ON_OFF, 0);

	//   
        //printf ("%c -3- ",r1);
        r1=MMC_SendCommand(MMC_SET_BLOCKLEN, 512);//   

	//printf ("%c -4-\r",r1);
	return r1;
}
  
//=============================================================================
BYTE MMC_ReadSector(DWORD sector) {
	char r1;
	int i;

	SD_CS_ON();// 
	LED_ON(); //  

	r1=MMC_Command(MMC_READ_SINGLE_BLOCK, sector<<9);//  
	if(r1!=0)return r1;//      

	while(spi(0xFF)!=MMC_STARTBLOCK_READ);//  

	for(i=0;i<512;i++) { //   
		SectorBuffer[i]=spi(0xFF);
	} 

	// 2  CRC
	spi(0xFF);
	spi(0xFF);

	SD_CS_OFF();// 
	spi(0xFF);

	LED_OFF(); //  
	return 0;
} 

// =============================================================================
//  ()      (..    )
//===========================
BYTE ReadCluster(DWORD cluster) {
	BYTE result;

	result = MMC_ReadSector(cluster + Fat2Cluster);
	F_ClusterBuf = cluster; //      
	                        //  ,        
	return result;
}

// =============================================================================
//      
//===========================
BYTE FAT_init(void) {
        BYTE result;

        //   ()  (MBR - Master Boot Record)
        result = MMC_ReadSector(0);
        if (result) return result; //    
        
        if (SectorBuffer[510] != 0x55 || SectorBuffer[511] != 0xAA)
                return 0xAA; // :    MBR
        
        MBR_FAT_filetype = SectorBuffer[PARTITION_START+4]; // (446 + 04h) -   

        MBR_sector_BIOS_PB = SectorBuffer[PARTITION_START+11]; // (446 + 08h) -  ()   
        MBR_sector_BIOS_PB <<=8;                               //
        MBR_sector_BIOS_PB += SectorBuffer[PARTITION_START+10];//
        MBR_sector_BIOS_PB <<=8;                               //
        MBR_sector_BIOS_PB += SectorBuffer[PARTITION_START+9]; //
        MBR_sector_BIOS_PB <<=8;                               //
        MBR_sector_BIOS_PB += SectorBuffer[PARTITION_START+8]; //

        //       ( BIOS Parameter Block)
        result = MMC_ReadSector(MBR_sector_BIOS_PB);
        if (result) return result; //    

        BPB_SectSize = SectorBuffer[0x0c];  //     (  BIOS PB)[  512]
        BPB_SectSize <<=8;                  //
        BPB_SectSize += SectorBuffer[0x0b]; //

        BPB_ClustSize = SectorBuffer[0x0D]; //     (  BIOS PB)

        BPB_ResSect = SectorBuffer[ 0x0f];  //     FAT#1 (  BIOS PB) 
        BPB_ResSect <<=8;                   //
        BPB_ResSect += SectorBuffer[ 0x0e]; //

        BPB_FatCnt = SectorBuffer[0x10];    // -  FAT   (  BIOS PB)[  2]

        BPB_RootSize = SectorBuffer[0x12];  //  32-    ( FAT16   512)
        BPB_RootSize <<=8;                  //                                                  ( FAT32   0)
        BPB_RootSize += SectorBuffer[0x11]; //

        BPB_FatSize = SectorBuffer[0x17];   //     FAT (  BIOS PB)
        BPB_FatSize  <<=8;                  //
        BPB_FatSize  += SectorBuffer[0x16]; //

        //   
        FAT_begin = MBR_sector_BIOS_PB + BPB_ResSect; //  FAT
        Root_dir_begin = FAT_begin + (BPB_FatSize * BPB_FatCnt); //   
        Data_begin = Root_dir_begin + (BPB_RootSize * 32 / 512); //    ( 2)

        //         FAT  
        Fat2Cluster = Data_begin - 2;

        return 0;
}



//===============================================================================================
//        FAT
//  :    
// ====================================
DWORD NextCluster (DWORD cluster) {
	DWORD tmp1, tmp2, tmp3, tmp4, tmp5;

	tmp1 = cluster / 256; //    FAT (  FAT)
	tmp2 = FAT_begin + tmp1; //    
	tmp3 = cluster % 256; //      (..  )
	tmp4 = 2 * tmp3; //    

	MMC_ReadSector(tmp2);
        
	tmp5 = SectorBuffer[tmp4+1]; //   
	tmp5 <<=8;                   //
	tmp5 += SectorBuffer[tmp4];  //

	F_ClusterBuf=0; //  0 ..        

	return tmp5; //    ()
}

/*
//===============================================================================================
//       (  )
//  :    
// ====================================
void PrintFile (DWORD cluster) {
        WORD i;
        do {
              ReadCluster(cluster);
              printf("\rPrint cluster %u:\r", cluster);
              for (i=0;i<512;i++) {
                     if (SectorBuffer[i] != 0x00) putchar (SectorBuffer[i]);
              }
              cluster= NextCluster(cluster);
        } while (cluster != 0xFFFF);
        printf("\r");
}
*/

//===============================================================================================
//       (  FAT)
//  :   
// ====================================
void PrintFat (DWORD num) {
    DWORD i, ns;

    for (i=2;i<num;i++) {
            ns=NextCluster(i);
            if (ns!=0xFFFF) { printf("\rCluster %u -> Next Cluster %u", i, ns); }
            else            { printf(" Cluster %u TheEnd", i); }
    }
}


//===============================================================================================
//  :           
//   
//===========================
BYTE ReadByteFile (DWORD cluster, DWORD P) {
	DWORD i, d, num;

	num = P / 512; //   (    )     
	d = num;

	if (num == 0) { //   512        
		if (cluster != F_ClusterBuf) { 
			ReadCluster(cluster); //         
			F_ClusterBuf = cluster;
			F_ClusterNum = num;
		}
		return SectorBuffer[P]; //  
	}
	else {
		if (num != F_ClusterNum) { //      
			if (num > F_ClusterNum) { //      
				d = num - F_ClusterNum; //      ,  
				cluster = F_ClusterBuf; // <-   (   )
			}

			//        ->    
			//         ->      
			for (i=0;i<d;i++) { //           
				cluster = NextCluster(cluster);
			}
			
			ReadCluster(cluster); //  
			F_ClusterBuf = cluster;
			F_ClusterNum = num;		
		}
		i = P % 512;
		return SectorBuffer[i]; //   
	}
}

//===============================================================================================
//  :             
//    
//==================================
void ReadFile (DWORD cluster, BYTE *buf, DWORD len) {
	DWORD i;

	for (i=0;i<len;i++) { //         
		buf[i] = ReadByteFile (cluster, i);
	}
}



//===============================================================================================
//
//
BYTE OpenFile (BYTE NameFile[13]) {

	BYTE result, record, attrib, i,
	F_Name[13], //     
	S_NameFile[13]; //   

	WORD sector=0;

	//      ..
	for (i=0;i<12;i++){ S_NameFile[i] = tolower(NameFile[i]); }

	//   
	sector = Root_dir_begin;
	result = MMC_ReadSector(sector);

	record =0;
	while((result==0) && SectorBuffer[record*32]!=0){

		if (SectorBuffer[record*32] != 0xe5) { //    -   ,  
			
			attrib = SectorBuffer[(record*32)+11]; //  

			if (attrib == FILE_TYPE_FILE) { 

				//
				//        11  (8+3)    
				//         8 .   
				// 3 .    .
				// 
				//            
				//        .
				//

				for (i=0;i<8;i++){ 
					if (SectorBuffer[(record*32)+i] != ' ') F_Name[i] = SectorBuffer[(record*32)+i];
				else break;
				}
				F_Name[i] = '.';
				F_Name[i+1] = SectorBuffer[(record*32)+8]; if (F_Name[i+1] == ' ') {F_Name[i+1]=0x00;F_Name[i]=0x00;}
				F_Name[i+2] = SectorBuffer[(record*32)+9]; if (F_Name[i+2] == ' ') {F_Name[i+2]=0x00;}
				F_Name[i+3] = SectorBuffer[(record*32)+10];if (F_Name[i+3] == ' ') {F_Name[i+3]=0x00;}
				F_Name[i+4] = 0x00;

				//    
				F_Size = SectorBuffer[(record*32)+0x1F];
				F_Size <<= 8;
				F_Size += SectorBuffer[(record*32)+0x1E];
				F_Size <<= 8;
				F_Size += SectorBuffer[(record*32)+0x1D];
				F_Size <<= 8;
				F_Size += SectorBuffer[(record*32)+0x1C];
				CelBlock  = F_Size / 512; //   
				DrobBlock = F_Size % 512; //     

				//   
				F_StartCluster = SectorBuffer[(record*32)+0x15];
				F_StartCluster <<= 8;
				F_StartCluster += SectorBuffer[(record*32)+0x14];
				F_StartCluster <<= 8;
				F_StartCluster += SectorBuffer[(record*32)+0x1B];
				F_StartCluster <<= 8;
				F_StartCluster += SectorBuffer[(record*32)+0x1A];

				//        ..
				for (i=0;i<12;i++){ F_Name[i] = tolower(F_Name[i]); }
			
				//       .
				if (!strcmp(F_Name, S_NameFile)) return 1; //    

				//     
				//printf("NameFile = %s -> S_NameFile = %s <-> F_Name = %s \r", NameFile, S_NameFile, F_Name);
			}
		}
		
		//      
		record++;
		
		if (record==16){ //  ()   16  (  0  15)
		record = 0;
		sector++;
		result = MMC_ReadSector(sector);
		}
	}
	return 0; //    
}


//===============================================================================================
//      8-   
//  256  .
//   2.000.000      (2.000.000 / 256) = 7812,5 
//
// 0xFF - 0x89 = 0x77 (   256 - 137 = 119)
// 2.000.000 / 119 = 16806,72 
//
// Timer 0 overflow interrupt service routine
//===========================================
interrupt [TIM0_OVF] void timer0_ovf_isr(void) {
        //   Timer 0  
        TCNT0=0x89; //  . = 137
        PORTA = data;
}

//===============================================================================================
// External Interrupt 0 service routine
//=====================================
interrupt [EXT_INT0] void ext_int0_isr(void) {
//        cluster_tmp++;
//        PrintFile (cluster_tmp);
}

//===============================================================================================
// External Interrupt 1 service routine
//=====================================
interrupt [EXT_INT1] void ext_int1_isr(void) {
//        cluster_tmp--;
//        if (cluster_tmp < 2) cluster_tmp = 2;     
//        PrintFile (cluster_tmp);
}

//===============================================================================================
//  
//========================
void Init(void) {
// Input/Output Ports initialization
// Port A initialization
//    
//  ( 0)  
DDRA=0xFF;
PORTA=0x00;

// Port B initialization
// bit7=Out bit6=In bit5=Out bit4=Out bit3=In     bit2=In bit1=In bit0=Out 
// bit7=0   bit=T   bit5=0   bit4=0   bit3=Pullap bit2=T  bit1=T  bit0=0 
DDRB=0xB1;
PORTB=0x08;

// Port C initialization
//     
// pullap    
DDRC=0x00;
PORTC=0xFF;

// Port D initialization
//    
// pullap   2  3
DDRD=0x00;
PORTD=0x0C;


// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 2000,000 kHz
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x02;
TCNT0=0x89;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: On
// INT1 Mode: Falling Edge
// INT2: Off
GICR|=0xC0;
MCUCR=0x0A;
MCUCSR=0x00;
GIFR=0xC0;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;//TIMSK=0x01;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
//UBRRL=0x67; // USART Baud Rate: 9600
UBRRL=0x19; // USART Baud Rate: 38400

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// SPI initialization
// SPI Type: Master
// SPI Clock Rate: 125,000 kHz
// SPI Clock Phase: Cycle Half
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
//SPCR=0x53;
//SPCR=0x52; // SPI Clock Rate: 250,000 kHz
SPCR=0x51; // SPI Clock Rate: 1000,000 kHz
SPSR=0x00;
}

//========================================= MAIN ================================================
void main(void) {
// Declare your local variables here
BYTE result, i, F_Name[13], F[13]="math.lib";
BYTE record;
BYTE attrib;
WORD sector=0, vsegozap=0;
DWORD x;
TW tw;

//  
Init();

printf("SD-card reader Demo using the CodeVisionAVR C Compiler\r");
printf("******************************************************\r");

//   
#asm("sei")

MMC_Init();
SPSR=0x01; // SPI = 2x (    SPI)
FAT_init();

//    Fat

printf("FAT boot Sector info :\rPart type                                        : ");
if (MBR_FAT_filetype == PART_TYPE_UNKNOWN)    printf("UNKNOWN\r");
if (MBR_FAT_filetype == PART_TYPE_FAT12)      printf("FAT12\r");
if (MBR_FAT_filetype == PART_TYPE_XENIX)      printf("XENIX\r");
if (MBR_FAT_filetype == PART_TYPE_DOSFAT16)   printf("DOSFAT16\r");
if (MBR_FAT_filetype == PART_TYPE_EXTDOS)     printf("EXTDOS\r"); 
if (MBR_FAT_filetype == PART_TYPE_FAT16)      printf("FAT16\r");
if (MBR_FAT_filetype == PART_TYPE_NTFS)       printf("NTFS\r");
if (MBR_FAT_filetype == PART_TYPE_FAT32)      printf("FAT32\r");
if (MBR_FAT_filetype == PART_TYPE_FAT32LBA)   printf("FAT32LBA\r");
if (MBR_FAT_filetype == PART_TYPE_FAT16LBA)   printf("FAT16LBA\r");
if (MBR_FAT_filetype == PART_TYPE_EXTDOSLBA)  printf("EXTDOSLBA\r");
if (MBR_FAT_filetype == PART_TYPE_ONTRACK)    printf("ONTRACK\r"); 
if (MBR_FAT_filetype == PART_TYPE_NOVELL)     printf("NOVELL\r");
if (MBR_FAT_filetype == PART_TYPE_PCIX)       printf("PCIX\r");
if (MBR_FAT_filetype == PART_TYPE_PHOENIXSAVE)printf("PHOENIXSAVE\r");
if (MBR_FAT_filetype == PART_TYPE_CPM)        printf("CPM\r");
if (MBR_FAT_filetype == PART_TYPE_DBFS)       printf("DBFS\r");
if (MBR_FAT_filetype == PART_TYPE_BBT)        printf("BBT\r");


printf("Nomer nachal.razdela (MBR_sector_BIOS_PB)        = %u \r", MBR_sector_BIOS_PB);
printf("Kol-vo byte v sectore (BPB_SectSize)             = %u \r", BPB_SectSize);
printf("Kol-vo sectorov v clastere (BPB_ClustSize)       = %u \r", BPB_ClustSize);
printf("Ko-lvo Rezervn.sectorov (BPB_ResSect)            = %u \r", BPB_ResSect);
printf("Vsego tablic FAT (BPB_FatCnt)                    = %u \r", BPB_FatCnt);
printf("Chislo 32-byte element v root dir (BPB_RootSize) = %u \r", BPB_RootSize);
printf("Sectorov v odnoi FAT (BPB_FatSize)               = %u \r", BPB_FatSize);

printf("Nachalo tabl.FAT (FAT_begin)            = %u \r", FAT_begin);
printf("Nachalo Root dir (Root_dir_begin)       = %u \r", Root_dir_begin);
printf("Nachalo dannix - Cluster 0 (Data_begin) = %u \r\n", Data_begin);



//   
sector = Root_dir_begin;
result = MMC_ReadSector(sector);


record =0;
while((result==0) && SectorBuffer[record*32]!=0){
	//   
	if (SectorBuffer[record*32] != 0xe5){ //   )
		//  
		attrib = SectorBuffer[(record*32)+11];
		if (attrib == FILE_TYPE_FILE || attrib == FILE_TYPE_DIR ){ // entry is normal 8.3 entry
			if (attrib == FILE_TYPE_DIR) putchar('[');
			
			// construct short filename string
/*
			for (i=0;i<8;i++){ 
				F_Name[i] = SectorBuffer[(record*32)+i];
			}
			F_Name[8] = '.';
			F_Name[9] = SectorBuffer[(record*32)+8];
			F_Name[10] = SectorBuffer[(record*32)+9];
			F_Name[11] = SectorBuffer[(record*32)+10];
			F_Name[12] = 0x00;
			printf("%s", F_Name);
			if (attrib == FILE_TYPE_DIR) putchar(']');
			putchar('\t');
*/

			for (i=0;i<8;i++){ 
				if (SectorBuffer[(record*32)+i] != ' ') F_Name[i] = SectorBuffer[(record*32)+i];
				else break;
			}
			F_Name[i] = '.';
			F_Name[i+1] = SectorBuffer[(record*32)+8];
			F_Name[i+2] = SectorBuffer[(record*32)+9];
			F_Name[i+3] = SectorBuffer[(record*32)+10];
			F_Name[i+4] = 0x00;

			if (attrib == FILE_TYPE_FILE) { //      
				for (i=0;i<12;i++) F_Name[i] = tolower(F_Name[i]);
			}

			printf("%s", F_Name);
			if (attrib == FILE_TYPE_DIR) putchar(']');
			putchar('\t');
								
			//   () 
			F_Size = SectorBuffer[(record*32)+0x1F];
			F_Size <<= 8;
			F_Size += SectorBuffer[(record*32)+0x1E];
			F_Size <<= 8;
			F_Size += SectorBuffer[(record*32)+0x1D];
			F_Size <<= 8;
			F_Size += SectorBuffer[(record*32)+0x1C];
			CelBlock  = F_Size / 512; //   
			DrobBlock = F_Size % 512; //     
			
			printf("Size = %u (%u)(%u)\t", F_Size, CelBlock, DrobBlock);

			//   
			F_StartCluster = SectorBuffer[(record*32)+0x15];
			F_StartCluster <<= 8;
			F_StartCluster += SectorBuffer[(record*32)+0x14];
			F_StartCluster <<= 8;
			F_StartCluster += SectorBuffer[(record*32)+0x1B];
			F_StartCluster <<= 8;
			F_StartCluster += SectorBuffer[(record*32)+0x1A];
			printf("Cluster = %u\t", F_StartCluster);

			// 
			printf("filenumber = %u \r", record+(sector<<4));
		}
	}
		
	//      
	record++;
		
	if (record==16){ //  ()   16  (  0  15)
		record = 0;
		sector++;
		result = MMC_ReadSector(sector);
	}

vsegozap++;
}

printf("Vsego %u zapisei\r", vsegozap);

//========================================================
//cluster_tmp=2;

printf("\r**************************************\r");

//PrintFat(350); //  350  FAT 


if (OpenFile(F)) { 
        printf("File Open: %s", F);
        //PrintFile (F_StartCluster);
        for (x=0;x<F_Size;x++) {
                i = ReadByteFile(F_StartCluster,x);
                if (i != '\n') putchar (i);
        }
} else printf ("ERROR: File %s not open !!!", F);

//  WAV 


/*
if (OpenFile(F)) { 
        printf("File Open: %s\r", F);

        for (x=0;x<44;x++) {
                i = ReadByteFile(F_StartCluster,x);
                printf ("%x - %u - %c\r", i, i, i);
        }

        printf ("-=-=-=-=-=-=-=-=-\r");

        ReadFile (F_Cluster, (BYTE *)&tw, 44);
	if ( strncmpf(tw.id_riff,"RIFF",4) != 0 ) printf("Not RIFF\r"); else printf("RIFF OK\r"); //    RIFF
	if ( strncmpf(tw.id_chuck,"WAVE",4) != 0 ) printf ("Not WAV\r"); else printf("WAV OK\r"); //    CHUCK
	if ( strncmpf(tw.fmt,"fmt ",4)!= 0 ) printf ("Not FMT\r"); else printf("FMT OK\r");       //    FMT
	if ( tw.type != 1 ) printf ("Not data\r"); else printf("data OK\r");                      //   -  
	if ( tw.channels != 1 ) printf ("Not mono\r"); else printf("mono OK\r");                  //  
	if ( tw.freq != 16000 ) printf ("Not 16000 Hz\r"); else printf("16000 Hz OK\r");          //  16000 
	if ( tw.bytes != 16000 ) printf ("Not 16000 Hz\r");
	if ( tw.bits != 8 ) printf ("Not 8 bit\r"); else printf("8 bit OK\r");                             //  8 
	if ( strncmpf(tw.id_data,"data",4)!= 0 ) printf ("Not ident DATA"); else printf("ident DATA OK\r");//    DATA

//        TIMSK=0x01;
//        for (x=44;x<F_Size;x++) {
//                data = ReadByteFile(F_StartCluster,x);
//                PORTA = data;
//                delay_us(1);
//                sleep_enable();
//        }
//        TIMSK=0x00;
} else printf ("ERROR: File %s not open !!!", F);
*/



while (1) {

}


} // ============= End main =============
